package com.xiaoliu.codec;

import com.xiaoliu.protocol.Packet;
import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandler;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.MessageToMessageCodec;
import lombok.extern.slf4j.Slf4j;

import java.util.List;

@Slf4j
@ChannelHandler.Sharable
public class CodecHandler extends MessageToMessageCodec<ByteBuf, Object> {

	@Override
	protected void encode(ChannelHandlerContext ctx, Object o, List<Object> list) throws Exception {
		if (o instanceof Packet) {
			ByteBuf byteBuf = ctx.channel().alloc().ioBuffer();
			Codec.INSTANCE.encode(byteBuf, (Packet) o);
			list.add(byteBuf);
		} else {
			log.info("File ByteBuf need encode");
			// ctx.writeAndFlush(o);
		}
	}

	@Override
	protected void decode(ChannelHandlerContext ctx, ByteBuf byteBuf, List<Object> list) throws Exception {
		if (byteBuf.getInt(0) == Codec.TYPE) {
			System.out.println("decode FilePacket");
			list.add(Codec.INSTANCE.decode(byteBuf));
		} else {
			log.info("File ByteBuf need decode");
			// list.add(byteBuf);
			ctx.fireChannelRead(byteBuf);
		}
	}
}
