package com.xiaoliu.handler;

import com.xiaoliu.protocol.request.LoginPacket;
import com.xiaoliu.protocol.response.LoginResponsePacket;
import com.xiaoliu.protocol.session.Session;
import com.xiaoliu.util.IDUtil;
import com.xiaoliu.util.LoginUtil;
import com.xiaoliu.util.SessionUtil;
import io.netty.channel.ChannelHandler;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.SimpleChannelInboundHandler;
import lombok.extern.slf4j.Slf4j;

import java.util.Date;

@Slf4j
@ChannelHandler.Sharable
public class JoinClusterRequestHandler extends SimpleChannelInboundHandler<LoginPacket> {
	@Override
	protected void channelRead0(ChannelHandlerContext ctx, LoginPacket loginPacket) {
		String id = IDUtil.randomId();
		loginPacket.setId(id);
		log.info("{} [{}-{}]加入集群", new Date(), loginPacket.getName(), id);
		LoginUtil.bindUser(loginPacket, ctx.channel());
		ctx.writeAndFlush(new LoginResponsePacket(id, loginPacket.getName()));
	}

	@Override
	public void channelInactive(ChannelHandlerContext ctx) throws Exception {
		LoginUtil.unBind(ctx.channel());
	}
}
